#
# (C) Alexey R. Buzykaev, buzykaev@inp.nsk.su
#     Dmitry A. Fedorov,   fedorov@inp.nsk.su
#
# $Id: progdefs.make,v 1.24 2003/07/04 08:14:47 fedorov Exp $
#
# program definitions for project Makefile

DEP_FILES += $(dfmake_dir)/progdefs.make

LN   ?= ln
LN_S ?= $(LN) -s
CP   ?= cp
MV   ?= mv -f
RM   ?= rm -f		# default

SHTOOL = $(dfmake_dir)/shtool

INSTALL ?= $(SHTOOL) install -c
MKDIR   ?= $(SHTOOL) mkdir -f

RMDIR_P	?= $(dfmake_dir)/rmdir_p

AR ?= ar			# default

ifndef AS
  ifdef    dfconfig_time_AS
    AS = $(dfconfig_time_AS)
  else
    AS = as		# default
  endif
endif

ifndef CC
  ifdef    dfconfig_time_CC
    CC = $(dfconfig_time_CC)
  else
    CC = gcc
  endif
else
  ifeq "$(origin CC)" "default"
    ifdef    dfconfig_time_CC
      CC = $(dfconfig_time_CC)
    else
      CC = gcc		# default: cc
    endif
  endif
endif

ifndef CXX
  ifdef     dfconfig_time_CXX
    CXX = $(dfconfig_time_CXX)
  else
    CXX = g++
  endif
else
  ifeq "$(origin CXX)" "default"
    ifdef     dfconfig_time_CXX
      CXX = $(dfconfig_time_CXX)
    else
      CXX = g++		# default: g++
    endif
  endif
endif

ifndef CPP
  ifdef     dfconfig_time_CPP
    CPP = $(dfconfig_time_CPP)
  else
    CPP = $(CC) -E	# default
  endif
else
  ifeq "$(origin CPP)" "default"
    ifdef     dfconfig_time_CPP
      CPP = $(dfconfig_time_CPP)
    else
      CPP = $(CC) -E	# default
    endif
  endif
endif

ifndef CXXPP
  ifdef       dfconfig_time_CXXPP
    CXXPP = $(dfconfig_time_CXXPP)
  else
    CXXPP = $(CXX) -E	# default
  endif
else
  ifeq "$(origin CXXPP)" "default"
    ifdef       dfconfig_time_CXXPP
      CXXPP = $(dfconfig_time_CXXPP)
    else
      CXXPP = $(CXX) -E	# default
    endif
  endif
endif

ifndef LD
  ifdef    dfconfig_time_LD
    LD = $(dfconfig_time_LD)
  else
    LD = ld		# default
  endif
else
  ifeq "$(origin LD)" "default"
    ifdef    dfconfig_time_LD
      LD = $(dfconfig_time_LD)
    endif
  endif
endif

ifeq "$(target_os)" "linux-gnu"
  ifndef GENKSYMS
    ifdef          dfconfig_time_GENKSYMS
      GENKSYMS = $(dfconfig_time_GENKSYMS)
    else
      GENKSYMS = genksyms
    endif
  endif
endif


#MAKE	= make		# default
MAKE := $(MAKE) -r

